;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                              Day Of Week                              ;;
;;                                                                       ;;
;;  Displays the day of the week and the current date.  Then exits with  ;;
;;  the day of the week as the error level (0 = Sunday, etc..).          ;;
;;                                                                       ;;
;;  Written by Dave Navarro, Jr.                                         ;;
;;  BBS:       718-837-3236                                              ;;
;;  CIS:       73002, 3506                                               ;;
;;  Internet:  dave.navarro@consultant.com                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Code    Segment Byte
        Assume CS: Code, DS: Code

        ORG     100H
Start:
        jmp     DayOfWk

Msg1    DB      13,10,"Today is $"
Msg2    DB      ", $"
Msg3    DB      13,10,"$"

Days    DB      "Sunday$   "
        DB      "Monday$   "
        DB      "Tuesday$  "
        DB      "Wednesday$"
        DB      "Thursday$ "
        DB      "Friday$   "
        DB      "Saturday$ "

Months  DB      "January $  "
        DB      "February $ "
        DB      "March $    "
        DB      "April $    "
        DB      "May $      "
        DB      "June $     "
        DB      "July $     "
        DB      "August $   "
        DB      "September $"
        DB      "October $  "
        DB      "November $ "
        DB      "December $ "

Number  DB      "00$"

WeekDay DB      ?
Month   DB      ?
Day     DB      ?
Year    DW      ?

DayOfWk Proc
        mov     AH, 2Ah                 ; get system date
        int     21h                     ; call DOS

        mov     WeekDay, AL             ; save day of week
        dec     DH                      ; make month zero based
        mov     Month, DH               ; save month
        mov     Day, DL                 ; save day
        mov     Year, CX                ; save year

        mov     DX, OFFSET Msg1         ; point to first message
        mov     AH, 9                   ;
        int     21h                     ; display it

        mov     AL, WeekDay             ; put day of week in AL
        mov     BL, 10                  ; 10 bytes per record in names
        mul     BL                      ; AX = AL * BL

        mov     DX, OFFSET Days         ; point to day names
        add     DX, AX                  ; add offset to today
        mov     AH, 9                   ;
        int     21h                     ; display it

        mov     DX, OFFSET Msg2         ; point to second message
        mov     AH, 9                   ;
        int     21h                     ; display it

        mov     AL, Month               ; put month in AL
        mov     BL, 11                  ; 10 bytes per record in names
        mul     BL                      ; AX = AL * BL

        mov     DX, OFFSET Months       ; point to month names
        add     DX, AX                  ; add offset to this month
        mov     AH, 9                   ;
        int     21h                     ; display it

        mov     AL, Day                 ; put day in AL
        aam                             ; convert to BCD
        add     AX, '00'                ; convert to ASCII
        xchg    AL, AH                  ; flip bytes
        mov     BX, OFFSET Number       ; point to number
        mov     CS:[BX], AX             ; store day
        cmp     Byte Ptr CS:[BX], '0'   ; is it a single digit day?
        jne     DisplayDay              ; no, display it
        inc     BX                      ; yes, skip first 0
DisplayDay:
        mov     DX, BX                  ; point DX to number
        mov     AH, 9                   ;
        int     21h                     ; display it

        mov     DX, OFFSET Msg2         ; point to second message
        mov     AH, 9                   ;
        int     21h                     ; display it

        xor     DX, DX                  ; clear DX
        mov     AX, Year                ; put year in AX
        mov     BX, 100                 ; we want the century
        div     BX
        mov     Year, DX                ; save decade and year in Year

        aam                             ; convert to BCD
        add     AX, '00'                ; convert to ASCII
        xchg    AL, AH                  ; flip bytes
        mov     BX, OFFSET Number       ; point to number
        mov     CS:[BX], AX             ; store day

        mov     DX, BX                  ; point DX to number
        mov     AH, 9                   ;
        int     21h                     ; display it

        mov     AX, Year                ; put year in AX
        aam                             ; convert to BCD
        add     AX, '00'                ; convert to ASCII
        xchg    AL, AH                  ; flip bytes
        mov     BX, OFFSET Number       ; point to number
        mov     CS:[BX], AX             ; store decade and year

        mov     DX, BX                  ; point DX to number
        mov     AH, 9                   ;
        int     21h                     ; display it

        mov     DX, OFFSET Msg3         ; point to third message
        mov     AH, 9                   ;
        int     21h                     ; display it
Exit:
        mov     AL, WeekDay             ; put day of week in AL
        mov     AH, 4Ch                 ; exit day of week as error level
        int     21h                     ;
DayOfWk EndP
Code    EndS
        End Start
